* ==================================================================================================
***  :
*    :       QR       27.11.2018
*
*     
*             1251
* ==================================================================================================

#include "windows.ch"
#include "guilib.ch"
#define CRLF (CHR(13)+CHR(10))
#define TRUE .T.
#define FALSE .F.

//    

#xcommand FOR <i>:=<s> TO <n> DO <*statement*> =>;
                            FOR <i>:=<s> TO <n> ; <statement> ; END
#xcommand IF <cond> THEN <*statement*>          =>;
                            IF <cond> ; <statement>; ENDIF
#xcommand DEFAULT <p> TO <v> [, <p2> TO <v2> ] => ;
                  <p> := IF(<p> == NIL, <v>, <p>) ;
                  [; <p2> := IF (<p2> == NIL, <v2>, <p2>) ]

//     
STAT cgBackCol  := "336633" //     
STAT cgColor    := "ffff99" //    
STAT cgCodePage := "RU866"  //     Dbf 

//     ,    
STAT oBitmap                //   QR    
STAT oBtmp                  //   BITMAP
STAT oEdit1                 //    
STAT oGet, oeW, oeH         //   GET   
STAT nIdCount := 1001       //    HDI 
STAT cBmp:=""               //       QR 
STAT cgPrinter:=""          //     -      

* --------------------------------------------------------------------------------------------------
*      
PROC Main()
    LOCA nWidthScr := hwg_GetDesktopWidth()     //     . 
    LOCA nHeightScr := hwg_GetDesktopHeight()   //     . 
    LOCA oFont, oArial, ob1, cH:="15 "
    LOCA oIcon:= HIcon():AddFile("Bob.ico")
    LOCA nLf:=0
    LOCA cNameOs:=Upper(OS())                   //   / -      
    PRIV cgTxt:="", oPict, nwW:=0, nwH:=0, nbW:=0, nbH:=0, nX:=0, nY:=0, nControl:=0, nTop:=0
    
    //    .     QR    
    oBitmap := HBitmap():AddFile("Zhdun.bmp")

    PREPARE FONT oFont NAME "MS Sans Serif" WIDTH 0 HEIGHT -13
    PREPARE FONT oArial NAME "Arial Cyr" WEIGHT 700 HEIGHT -12
    
    //     -    
    
    //     -   
    nwW := Max(740,Int(nWidthScr/2))   //   .   1024*768      
    nwH := Max(555,Int(nHeightScr/2))  //   
    INIT WINDOW oMainWind MAIN;
         TITLE " ,       QR  v: 181130";
         ICON oIcon FONT oFont;
         AT 1,1 SIZE nwW,nwH;
         BACKCOLOR hwg_ColorC2N("cccccc")
         
    oMainWind:Center()                          //   
    
    /*  .         
        :
        nbW := Int(nwW/4)
        nbH := Int(nwH/4)
        nX  := Int(nWidthScr/5.6)
        nY  := Int(nHeightScr/7)
    */
    nbW := nbH  := Int(Min(nwW,nwH)*1.3/3)  //  QR  , ..   
    nX  := Int((nwW-nbW)/2)-10              //    
    nY  := Int(nwH/3) - 80                  //      
 
    //         -       -  ,   
    @ nX,nY BITMAP oBtmp SHOW oBitmap ID nIdCount SIZE nbW, nbH ON CLICK {||pDemo()} 
    
/*        
    nControl        := Len(oMainWind:aControls)
    oBtmp           := oPict    := oMainWind:aControls[nControl]
    oBtmp:nBorder   := 10
*/    

    //***   29.11.2018     
    MENU OF oMainWind
        MENU TITLE "&" ID 31010
            MENUITEM "&"    ACTION lChBitmap( TRUE ) 
            IF At("WINDOWS",cNameOs)>0  //       Windows
                MENUITEM "&" ACTION hwg_PrintSetup(@cgPrinter)
            ENDI
            SEPARATOR
            MENUITEM "&x"       ACTION hwg_EndWindow()  //     
        ENDMENU
        MENUITEM "&"      ACTION hwg_Msginfo("   QR .   3."+CRLF+" xHarbour + HwGui ( )"+CRLF+CRLF+;
            "      ,         QR     <>     ."+CRLF+CRLF+;
            "    Windows     .    .     ,   "+CRLF+CRLF+;
            "           <>.       ."+CRLF+CRLF+;
            "        <>       ."+CRLF+CRLF+;
            "   ,    740555")
    ENDMENU

    //***         ,     QR 
    //     
    nTop    := nwH - 90
    
    //     ""   
    //     .     
    @ 10,nTop-26  SAY " : " FONT oArial SIZE 200, 26 BACKCOLOR hwg_ColorC2N("cccccc")
    @ 106,nTop-30 EDITBOX oEdit1 CAPTION " " SIZE nwW-260, 56 ON LOSTFOCUS {||cgTxt:=oEdit1:GetText(), .F.} STYLE ES_MULTILINE // *    @ 106,nTop-30 EDITBOX oEdit SIZE 390, 56 STYLE ES_MULTILINE // *    @ 106,nTop-30 HCEDIT oEdit1 SIZE 390, 56 ON LOSTFOCUS {||lChBitmap()}
    
    //         , ..    
    nLf     := nwW - 136
    
    //       
    @ nLf,nTop-26    SAY " :"  FONT oArial SIZE 70, 26 BACKCOLOR hwg_ColorC2N("cccccc")
    @ nLf+74,nTop-30 EDITBOX oeW CAPTION "15 " SIZE 38, 24
    
    @ nLf,nTop+4    SAY "  :" FONT oArial SIZE 70, 26 BACKCOLOR hwg_ColorC2N("cccccc")
    @ nLf+74,nTop   GET oeH VAR cH SIZE 38, 24    //  @ 578,nTop    EDITBOX oeH CAPTION "15" SIZE 38, 24
    
    @ 10,nTop     BUTTON "" SIZE 80, 26 ON CLICK {||lChBitmap()} 
    
    //      : @ 506,nTop-66 BUTTON "" SIZE 112, 26 ON CLICK {||pRpnQr()} 
    @ nLf,nTop-66 OWNERBUTTON ob1 OF oMainWind ID 108 TEXT "";
                  COLOR hwg_ColorC2N(cgColor) BACKCOLOR hwg_ColorC2N(cgBackCol);
                  SIZE 112, 30 ON CLICK {||lChBitmap(), pRpnQr()} 
    
    //        
    oEdit1:SetFocus()
    ACTIVATE WINDOW oMainWind

    //***           ACTIVATE WINDOW
    
    //     
    FileDelete("bmp*.bmp")
    RETU
    
* --------------------------------------------------------------------------------------------------
*    QR      .      cBmp
STAT PROC pRpnQr()
    LOCA cTxt:=Alltrim(oEdit1:GetText())
    IF Empty(cTxt)
        hwg_Msginfo("    QR   !")
        RETU
    ENDI
    IF Empty(cBmp)
        hwg_Msginfo("   <>    QR !")
        RETU
    ENDI

    pPintQR(cBmp,cTxt,Val(oeW:Value),Val(oeH:Value))
    RETU
    
* --------------------------------------------------------------------------------------------------
*      QR ,       EDIT       
FUNC lChBitmap( lNew )    
    LOCA cPict:="", oB, oB1
    MEMV cgTxt, oPict, nwW, nwH, nbW, nbH, nX, nY, nControl, nTop
    DEFAULT lNew TO FALSE
    ++nIdCount
    
    IF lNew //      
        oEdit1:value    := ""
        oeW:value       := oeH:value    := "15 "
    
        oB      := HBitmap():AddFile("zhdun.bmp")
        @ nX,nY BITMAP oB1 SHOW oB ID nIdCount SIZE nbW, nbH
        
        oEdit1:SetFocus()       //      
    ELSE    //   QR   
        cgTxt   := Alltrim(oEdit1:GetText())
    
        //   ,    
        IF Empty(cgTxt) THEN RETU TRUE
    
        //      QR         
        IF File("qr.bmp") THEN fErase("qr.bmp")
        cBmp    := zTemp("","bmp",32)

        //***              -   
        //   QR       
        cPict   := cQRGen(cgTxt,"",cBmp)
        oB  := HBitmap():AddFile(cBmp)
 
        //       
        @ nX,nY BITMAP oB1 SHOW oB ID nIdCount SIZE nbW, nbH
    ENDI
    RETU TRUE
    
* --------------------------------------------------------------------------------------------------
*           
PROC pDummy()
    RETU
    
* --------------------------------------------------------------------------------------------------
*     
PROC pDemo()
    LOCA nW:=hwg_GetDesktopWidth(), nH:=hwg_GetDesktopHeight()
    hwg_Msginfo(" : "+Str(nW) +"  : "+Str(nH)+CRLF+;
                " :   "+Str(nwW)+"  :   "+Str(nwH)+CRLF+;
                " : "+Str(Len(oMainWind:aControls))+CRLF+;
                " : "+IF(Empty(cgPrinter)," ",cgPrinter)+CRLF+;
                ": "+OS())    
    RETU

********************************************************************************
/*        
     
     QR

     ,    :
    oPrinter:NewLine()                          //     
    oPrinter:TextOut( Padc(cTxt,80) )           //    
          
    oBmp:Draw(oPrinter,{1500,1000,1700,1200})
    
    oBmp:Rect:= { 200,2000, 2000, 1500 }
    oPrn:DrawBitMap( oBmp )
    
         -  
*/
#define FORM_A4 9
#define PS_SOLID 0
#define RGB( nR,nG,nB ) ( nR + ( nG * 256 ) + ( nB * 256 * 256 ) )
#define BLACK RGB( 0x0 ,0x0 ,0x0 )
PROC pPintQR(cBmp,cTxt,nX,nY)
    LOCA aPos:={}, nI:=0
    LOCA nLeftStr:=0, nLeftCol:=0, nRightStr:=0, nRightCol:=0   //     
    LOCA cPrinter:="", oPrint, oBmp

*    hwg_Msginfo("cBmp="+cBmp+" cTxt="+cTxt+" nX="+Str(nX)+" nY="+Str(nY))

    //  nX, nY    -    
    nX  := nX*700/30
    nY  := nY*700/30
    
    //***      .  
    IF Empty(cgPrinter)
        cPrinter    := GetDefaultPrinter()      //   ,     
    ELSE
        cPrinter    := cgPrinter
    ENDI
    oPrinter    := Win32Prn():New(cPrinter)     //       ,     

    /*        .
           (BitNumber,PaperLanght,PaperWidht)  
          Create
    */
    oPrinter:Landscape  := .F.      //   
    oPrinter:FormType   := FORM_A4  //  4
    oPrinter:Copies     := 1        //   ...       

    //        ...    
    IF !oPrinter:Create()           //     
        hwg_Msginfo("   !    ,    ?")
        RETU
    ENDI

    //  -      
    IF !oPrinter:startDoc(" QR ")
        hwg_Msginfo(" startDoc      .   ,   -    !")

        //       ().
        oPrinter:Destroy()
        RETU
    ENDI

    //       ( ) -   (, , )
    oPrinter:SetPen(PS_SOLID, 1, BLACK)

    //   ,     .       ...  
    oPrinter:SetFont("Courier New",10,{4,-43})  //     
    oPrinter:Charset(255)                       //   -  OEM...  
    
    //***    ,         !!!!!!
    //             
    oPrinter:NewLine()              //     
    oPrinter:TextOut(cTxt)          //    
    
    //   bmp        100*260   nX*nY
    oBmp    := Win32BMP():new()             //   
    IF oBmp:loadFile( cBmp )                //   
        oBmp:Draw(oPrinter,{100,260,nX,nY})   //       . 15mm
    ENDI
    oBmp:Destroy()                          //   
    
    oPrinter:endDoc()                       //    
    oPrinter:Destroy()                      //    
    RETU

//    
#undef FORM_A4
#undef PS_SOLID
#undef RGB
#undef BLACK    


/*   QR          *.bmp
            QRCodelib     DLL  
    
    :
    cText     QR Code 
    cPath      
    cBmp      
    :     
*/
FUNC cQRGen(cText,cPath,cBmp)
    STAT qrDLL
    LOCA cFile:="", nResp:=0
    
    #Define DC_CALL_STD 0x0020
    DEFAULT cPath TO "", cBmp TO "QR.BMP", cText TO "http://check.egais.ru?id=UUID&dt=0404161630&cn=Common_Name"
    cFile   := cPath+cBmp
    
    IF !File("QRCodelib.Dll") THEN RETU ""
    
    qrDLL   := LoadLibrary("QRCodelib.Dll" )                        //     DLL 
    nResp   := DllCall(qrDLL,DC_CALL_STD,"FastQRCode",cText,cFile)  //      
    FreeLibrary(qrDLL)                                              //       
    RETU (cFile)
    

* --------------------------------------------------------------------------------------------------
*     TempFile     .     
*     . :
*   p     
*   t   
*   n    . 32-/
FUNC zTemp(p,t,n)
    LOCA cFile:="", nHand:=0, nI:=0
    p   := Upper(Alltrim(p))
    t   := Upper(Alltrim(Left(t,3)))

    FOR nI := 1 TO 99999
        cFile   := p+t+Alltrim(Str(nI,5))+"."+t
        IF !File(cFile)
            nHand   := fcreate(cFile)
            fclose(nHand)
            EXIT
        ENDI
    NEXT nI
    RETU (cFile)    
    
    
* --------------------------------------------------------------------------------------------------
*     , ..    HCEDIT     xHarbour     
FUNC HB_At(c,b); RETU At(c,b)
FUNC HB_RAt(c,b); RETU Rat(c,b)

